package graphe;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import carte.Arc;
import carte.Ville;

public class PathTree {
    private Map<Ville,Arc> fromParent;
    private Ville root;
    
    public PathTree(Ville o) {
        fromParent = new LinkedHashMap<Ville,Arc>();
        root = o;
        fromParent.put(root, new Arc(null, root, 0));
    }

    public Ville root() {
        return root;
    }

    public boolean member(Ville v){
        return fromParent.containsKey(v);
    }

    public int size() {
        return fromParent.size();
    }

    public Iterable<Ville> allVilles() {
        return fromParent.keySet();
    }

	public Iterable<Arc> allArcs() {
		return fromParent.values();
    }
	
    public Arc fromParent(Ville v) {
        return fromParent.get(v);
    } 

    // Ex 1: Compute route from root to destination
    //       paths contains all paths computed so far from root

    public void addArc(Arc a){
		// TODO
    }

    public List<Arc> pathToDestination(Ville destination){
	// TODO
        return null;
    }
}